// stdafx.cpp : Quelltextdatei, die nur die Standard-Includes einbindet
//	DesfireTest.pch ist die vorcompilierte Header-Datei
//	stdafx.obj enthlt die vorcompilierte Typinformation

#include "stdafx.h"

CString Byte2String(BYTE ch)
{
  CString str;
  str.Format("%02X",ch);
  return str;
}

CString Byte2StringBin(BYTE ch)
{
  CString str;
  for (int mask = 0x80; mask > 0; mask >>= 1)
  {
    str += (ch & mask)?'1':'0';
  }
  return str;
}

BYTE Hex(char ch)
{
  if ((ch >= '0') && (ch <= '9'))
    return ch - '0';
  else if ((ch >= 'A') && (ch <= 'F'))
    return ch - 'A' + 10;
  else if ((ch >= 'a') && (ch <= 'f'))
    return ch - 'a' + 10;
  else
    return 0;
}

BYTE MakeHex(const CString & str)
{
  if (str.GetLength() == 2)
    return Hex(str[0]) << 4 | Hex(str[1]);
  else if (str.GetLength() == 1)
    return Hex(str[0]);
  return 0;
}

BYTE MakeBin(const CString & str)
{
  BYTE b = 0;
  for (int i = 0; i <str.GetLength(); i++)
  {
    b <<= 1;
    b |= (str[i]=='1')?1:0;
  }
  return b;
}

void Hex2String(CString & str,BYTE * pBuff,int len)
{
  str.Empty();

  for (int i = 0; i<len; i++)
  {
    str += Byte2String(pBuff[i]);
    str += " ";
  }
  str.TrimRight(" ");
}

int String2Hex(BYTE * pBuff, int len, CString str)
{
  int idx = 0;
  int i = 0;
  if (str.Find("Error") >= 0)
    return 0;

  str.TrimLeft(' ');

  while (i < len)
  {
    idx = str.Find(' ');
    if (idx != -1)
    {
      pBuff[i++] = MakeHex(str.Left(idx));
      str = str.Mid(idx+1);
      str.TrimLeft(' ');
      if (str.IsEmpty())
        break;
    }
    else
    {
      if (!str.IsEmpty())
        pBuff[i++] = MakeHex(str);
      break;
    }
  }
  return i;
}

void Bin2String(CString &str, BYTE * pBuff, int len)
{
  str.Empty();
  for (int i = 0; i < len; i++)
  {
    str += Byte2StringBin(pBuff[i]);
    str += " ";
  }
  str.TrimRight(" ");
}

int String2Bin(BYTE * pBuff, int len, CString str)
{
  int idx = 0;
  int i = 0;
  if (str.Find("Error") >= 0)
    return 0;

  while (i < len)
  {
    idx = str.Find(' ');
    if (idx != -1)
    {
      pBuff[i++] = MakeBin(str.Left(idx));
      str = str.Mid(idx+1);
      str.TrimLeft(' ');
    }
    else
    {
      pBuff[i++] = MakeBin(str);
      break;
    }
  }
  return i;
}


